

@article{herlihywing90,
 author = {M. Herlihy and J. Wing},
 title = {{Linearizability: A Correctness Condition for Concurrent Objects}},
 journal = {ACM Transactions on Programming Languages and Systems (TOPLAS)},
 volume = {12},
 number = {3},
 year = {1990},
 pages = {463--492},
 publisher = {ACM Press},
}

@inproceedings{mittal98consistency,
    author = "N. Mittal and V. Garg",
    title = {{Consistency Conditions for Multi-Object Distributed Operations}},
    booktitle = "International Conference on Distributed Computing Systems",
    pages = "582-599",
    year = "1998",
}

@article{lamport79,
  author = {L. Lamport},
  title = {{How to Make a Multiprocessor that Correctly Executes Multiprocess Programs}},
  journal = "IEEE Trans. Comput.",
  volume = "9",
  pages  = "690--691",
  month = "September",
  year = "1979",
}

@article{afek93lazy,
  author = "Y. Afek and G. Brown and M. Merritt",
  title = {{Lazy Caching}},
  journal = "ACM Transactions on Programming Languages and Systems",
  volume = "15",
  number = "1",
  month = "January",
  publisher = "ACM Press",
  pages = "182--205",
  year = "1993",
}

@inproceedings{chamberlin76,
 author = {D. Chamberlin and R. Boyce},
 title = {{SEQUEL: A structured English query language}},
 booktitle = {Proceedings of the 1976 ACM SIGFIDET (now SIGMOD) workshop on Data description, access and control},
 year = {1976},
 pages = {249--264},
}

@article{papadimitriou79,
 author = {C. Papadimitriou},
 title = {{The Serializability of Concurrent Database Updates}},
 journal = {Journal of the ACM (JACM)},
 volume = {26},
 number = {4},
 year = {1979},
 pages = {631--653},
 publisher = {ACM Press},
}

@unpublished{bensalem-havelund03,
  author = {S. Bensalem and K. Havelund},
  title = {{Reducing False Positives in Runtime Analysis of Deadlocks}},
  note = {Submitted for publication},
  year = {2003},
  month = {January}
}

@book{Bernstein87,
  author="P. A. Bernstein and V. Hadzilacos and N. Goodman",
  title={{Concurrency Control and Recovery in Database Systems}},
  year=1987,
  publisher="Addison-Wesley",
}

@misc{Jtrek,
  author = "S. Cohen",
  title = "{Jtrek}",
  note = "Compaq,\\\verb+compaq.com/java/download/jtrek+",
  year = {1999},
}

@misc{Jprobe,
  author = "Sitraka",
  title = "{JProbe}",
  note = "\\\verb+www.sitraka.com/software/jprobe+",
  year = 2000
}

@manual{j2ee,
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = "{Java 2 Platform Enterprise Edition Specification}",
  note = "\\\verb+java.sun.com/j2ee+",
  year = {2002},
}

@book{gamma-helm-johnson-vlissides95,
   author = {E. Gamma and R. Helm and R. Johnson and J. Vlissides},
   publisher = {Addison-Wesley},
   title = {{Design Patterns -- Elements of Reusable Object-Oriented Software}},
   year = {1995},
}

@unpublished{goldberg-havelund02,
  author = {A. Goldberg and K. Havelund},
  title = {{A User-Friendly Package for Instrumenting Java Bytecode}},
  note = {Internal report},
  year = {2002}
}

@book{lea97,
   author = {D. Lea},
   publisher = {Addison-Wesley},
   title = {{Concurrent Programming in Java}},
   year = {1997},
}

@inproceedings{havelund00,
  author = "K. Havelund",
  title = "{Using Runtime Analysis to Guide Model Checking of Java Programs}",
  booktitle = "SPIN Model Checking and Software Verification",
  series = "LNCS",
  volume = 1885,
  pages = "245--264",
  publisher = "Springer",
  year = 2000
}

@inproceedings{havelund-rosu01-rv,
  author = {K. Havelund and G. Ro\c{s}u},
  title = {{Monitoring Java Programs with Java PathExplorer}},
  booktitle = {Proc. First International Workshop
               on Runtime Verification (RV'01)},
  series = {ENTCS},
  volume = {55},
  number = {2},
  year = {2001},
  pages = {97--114},
  address = {France},
  publisher = {Elsevier Science},
}

@misc{lea00,
  author = {D. Lea},
  title = "{Personal e-mail communication}",
  year   = 2000,
}

@inproceedings{ball-et-al01,
  author = "T. Ball and A. Podelski and S. Rajamani",
  title  = "{Boolean and Cartesian Abstractions for Model Checking C Programs}",
  booktitle= "Proc. TACAS'01: Tools and Algorithms for the
              Construction and Analysis of Systems",
  SERIES     = "LNCS",
  address = "Italy",
  year   = 2001,
}

@inproceedings{corbett-et-al00,
  author = "J. Corbett and M. B. Dwyer and J. Hatcliff and
            C. S. Pasareanu and Robby and S. Laubach and H. Zheng",
  title  = "{Bandera: Extracting Finite-state Models from Java Source Code}",
  booktitle= "Proc. 22nd International Conference on
              Software Engineering",
  address = "Ireland",
  publisher = "ACM Press",
  year   = 2000,
}

@inproceedings{holzmann-smith99,
  author      = "G. Holzmann and M. Smith",
  title       = "{A Practical Method for Verifying Event-Driven Software}",
  booktitle   = "Proc. ICSE'99, International Conference
                 on Software Engineering",
  address = "USA",
  publisher   = "IEEE/ACM",
  year        = 1999,
}

@inproceedings{stoller00,
  author = "S. D. Stoller",
  title = "{Model-Checking Multi-threaded Distributed Java Programs}",
  booktitle = "SPIN Model Checking and Software Verification",
  series = "LNCS",
  volume = 1885,
  year = 2000,
  pages = "224--244",
  publisher = "Springer",
}

@inproceedings{godefroid97,
  author = "P. Godefroid",
  title = "{Model Checking for Programming Languages using VeriSoft}",
  booktitle = "Proc. 24th ACM Symposium on Principles of
               Programming Languages",
  pages = "174--186",
  address = "France",
  year = 1997,
}

@inproceedings{visser-et-al00,
  author = "W. Visser and K. Havelund and G. Brat and
            S. Park",
  title = "{Model Checking Programs}",
  booktitle = "Proc. ASE'2000: The 15th IEEE International Conference
               on Automated Software Engineering",
  publisher   = "IEEE CS Press",
  year        = 2000,
}

@article{havelund-lowry-penix98,
  author = "K. Havelund and M. R. Lowry and J. Penix",
  title = "{Formal Analysis of a Space Craft Controller using SPIN}",
  journal = "IEEE Transactions on Software Engineering",
  volume = 27,
  number = 8,
  year = 2001,
  month = aug,
  pages  = "749-765",
  note = "An earlier version occurred in the Proceedings of the 4th SPIN
        workshop, 1998, Paris, France"
}

@article{havelund-pressburger00,
  author = "K. Havelund and T. Pressburger",
  title = "{Model Checking Java Programs using Java PathFinder}",
  journal = "International Journal on Software Tools for Technology Transfer",
  year = 2000,
  volume = 2,
  number = 4,
  pages = "366--381",
}

@techreport{detlefs-et-al98,
  author = "D. L. Detlefs and R. Leino and G. Nelson and
            J. B. Saxe",
  institution = "Compaq Systems Research Center, Palo Alto, California, USA",
  number = {159},
  title = "{Extended Static Checking}",
  year = 1998,
}

@inproceedings{harrow00,
  author = "J. Harrow",
  title = "{Runtime Checking of Multithreaded Applications with Visual Threads}",
  booktitle = "7th SPIN Workshop",
  series = "LNCS",
  volume = 1885,
  year = 2000,
  pages = "331--342",
  publisher = "Springer",
}

@article{rosenberg95thoughts,
    author = "A. L. Rosenberg",
    title = {{Thoughts on Parallelism and Concurrency in Computing Curricula}},
    journal = "ACM Computing Surveys",
    volume = "27",
    number = "2",
    pages = "280--283",
    year = "1995",
}

@article{schuldt-etal-TODS,
  author =   {H.~Schuldt and G.~Alonso and C.~Beeri and H.-J.~Schek},
  title =    {{Atomicity and Isolation for Transactional Processes}},
  journal =      {ACM Transactions on Database Systems (TODS)},
  year =     {2002},
  volume =   {27},
  number =   {1},
  pages =    {63-116}
}

@book{Reilly:Pthreads,
   author = {B. Nichols and D. Buttlar and J. P. Farrell},
   publisher = {O'Reilly},
   title = {{Pthreads Programming}},
   year = {1998},
}

@book{arnold-gosling96,
   author = {K. Arnold and J. Gosling},
   publisher = {Addison-Wesley},
   title = {{The Java Programming Language}},
   year = {1996},
}

@inproceedings{Artho2001,
  author={C. Artho and A. Biere},
  title={{Applying Static Analysis to Large-Scale, Multi-threaded Java Programs.}},
  editor={D. Grant},
  booktitle={Proc. 13th {ASWEC}},
  pages={68--75},
  year={2001},
  publisher={IEEE Computer Society},
}

@book{GoslingJoySteeleBracha2000,
  author={J. Gosling and B. Joy and G. Steele and G. Bracha},
  title={{The Java Virtual Language Specification, Second Edition}},
  publisher={Addison{-}Wesley},
  year={2000},
}

@manual{J2SE,
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = {{Java 2 SDK, Standard Edition Documentation}},
  note = {@ \texttt{java.sun.com/j2se/1.4/docs/}},
  year = {2002},
}

@manual{J2ME,
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = {Connected, limited device configuration. Specification version 1.0a, May 2000.},
  note = {@ \texttt{java.sun.com/j2me/docs/}},
  year = {2002},
}

@mastersthesis{Bruening99systematic,
  author = "D. Bruening",
  title = {{Systematic Testing of Multithreaded Java Programs}},
  school = "MIT",
  year = "1999",
}

@mastersthesis{Artho01FindingFaults,
  author = "C. Artho",
  title = {{Finding faults in multi-threaded programs}},
  school = "ETH",
  year = "2001",
}


@inproceedings{PraunGross2001,
  author={C. von Praun and T. Gross},
  title={{Object-Race Detection}},
  booktitle={{OOPSLA}},
  pages={70--82},
  year={2001},
  publisher={ACM},
}

@article{savage97eraser,
    author = "S. Savage and M. Burrows and G. Nelson and P. Sobalvarro and T. Anderson",
    title = {{Eraser: A Dynamic Data Race Detector for Multithreaded Programs}},
    journal = "ACM Transactions on Computer Systems",
    volume = "15",
    number = "4",
    pages = "391--411",
    year = "1997",
}

@book{StaerkSchmidBoerger2001,
  author={R. Staerk and J. Schmid and E. Boe<rger},
  title={{Java and the Java Virtual Machine}},
  publisher={Springer},
  year={2001},
}

@book{LindholmYellin1999,
  author={T. Lindholm and A. Yellin},
  title={{The Java Virtual Machine Specification, Second Edition}},
  publisher={Addison{-}Wesley},
  year={1999},
}

@book{Lea1999,
  author={D. Lea},
  title={{Concurrent Programming in Java, Second Edition}},
  publisher={Addison{-}Wesley},
  year={1999},
}

@book{Butenhof1997,
  author={D. Butenhof},
  title={{Programming with POSIX Threads}},
  publisher={Addison{-}Wesley},
  year={1997},
}

@book{NicholsButtlarFarrell1996,
  author={B. Nichols and D. Buttlar and J. Farrell},
  title={{Pthreads Programming}},
  publisher={O'Reilly},
  year={1996}
}

@inproceedings{Pell97,
  author = {B. Pell and E. Gat and R. Keesing and
            N. Muscettola and B. Smith},
  title = {{Plan Execution for Autonomous Spacecrafts}},
  booktitle = {Proceedings of the International Joint
               Conference on Artificial Intelligence},
  note = {Nagoya, Japan},
  year = {1997},
  month = {August},
  pages = {1234--1239}
}

@misc{ kim-javamac,
  author = "M. Kim and S. Kannan and I. Lee and O. Sokolsky and M. Viswanathan",
  title = "Java-mac: a run-time assurance tool for java programs",
  text = "Moonjoo Kim, Sampath Kannan, Insup Lee, Oleg Sokolsky, and Mahesh Viswanathan.
    Java-mac: a run-time assurance tool for java programs. In Klaus Havelund
    and Grigore",
  url = "citeseer.nj.nec.com/453289.html" }

@misc{ visualthreads,
  author ="Visual Threads",
  title = "http://h18000.www1.hp.com/products/software/visualthreads/index.html"
}

@misc{ Verisoft,
  author ="Verisoft",
  title = "http://www.bell-labs.com/project/verisoft/"
}

@misc{ ESC-Java,
  author ="ESC/Java",
  title = "http://research.compaq.com/SRC/esc/"
}

@misc{ Spin,
  author ="Spin",
  title = "http://spinroot.com/spin/whatispin.html"
}

@misc{ Bandera,
  author ="Bandera",
  title = "http://www.cis.ksu.edu/santos/bandera"
}

@misc{ JavaPathFinder,
  author ="Java PathFinder (JPF)",
  title = "http://ase.arc.nasa.gov/jpf/"
}

@misc{ Jlint,
  author ="Jlint",
  title = "http://www.ispras.ru/~knizhnik/jlint/ReadMe.html"
}

@misc{ Jlint-2,
  author ="Jlint",
  title = "http://artho.lcom/jlint"
}

@book{Tanenbaum-MOS,
  author="A. S. Tanenbaum",
  title={{Modern operating systems}},
  year={1992},
  publisher="Prentice Hall",
}

@book{Bach-Unix,
  author="M. J. Bach",
  title={{Unix operating system}},
  year={1986},
  publisher="Prentice Hall",
}

@inproceedings{God97,
  author = {Patrice Godefroid},
  title = {{Model checking for programming languages using Verisoft}},
  booktitle = {Proceedings of the 24th ACM Symposium on Principles of
               Programming Languages},
  note = {Paris, France},
  year = {1997},
  month = {January},
  pages = {174--186}
}

@book{God96,
  author="Patrice Godefroid",
  title={{Partial-Order Method for the Verification of Concurrent Systems -
          An approach to the State-Explosion Problem, volume 1032 of Lecture
          Notes in Computer Science }},
  year={1996},
  publisher="Springer-Verlag",
}

@misc{Hyperthreading,
  author = "Intel",
  title = "{Hyper-Threading Technology on the Intel Xeon Processor}",
  note = "http://www.intel.com/eBusiness/pdf/prod/server/xeon/wp020901.pdf"
}

@misc{ POSIX,
  author ="POSIX",
  title = "http://www.knosof.co.uk/posix.html"
}

@misc{ ASE,
  author ="NASA Ames Research Group",
  title = "http://ase.arc.nasa.gov/"
}

@article{ havelund00model,
    author = "Klaus Havelund and Thomas Pressburger",
    title = "Model Checking {JAVA} Programs using {JAVA} PathFinder",
    journal = "International Journal on Software Tools for Technology Transfer",
    volume = "2",
    number = "4",
    pages = "366-381",
    year = "2000",
    url = "citeseer.nj.nec.com/article/havelund99model.html" }


@misc{IA32DevMan,
  author = "Intel",
  title = "{IA-32 Intel Architecture Software Delevoper's Manual}",
  note = "http://www.intel.com/design/Pentium4/manuals/24547010.pdf"
}

@misc{ january-javanative,
  author = "Release January",
  title = "Java Native Interface Specification",
  url = "citeseer.nj.nec.com/51515.html" }

@misc{ MarcelBaur,
  author ="Email address of Marcel Baur",
  title = "mbaur@iiic.ethz.ch"
}

@misc{ Beowulf,
  author ="Beowulf",
  title = "http://www.beowulf.org/"
}

@book{Muchnick,
  author="S. Muchnick",
  title={{Advanced Compiler Design and Implementation}},
  year="1997",
  publisher="Morgan Kaufmann",
}

@misc{ VMWARE,
  author ="vmware",
  title = "http://www.vmware.com"
}

@misc{ valgrind,
  author ="valgrind",
  title = "http://developer.kde.org/~sewardj/"
}

@misc{ mit-pthreads,
  author ="MIT Pthreads",
  title = "http://www.humanfactor.com/pthreads/mit-pthreads.html"
}

@inproceedings{ stoller00modelchecking,
    author = "Scott D. Stoller",
    title = "Model-Checking Multi-threaded Distributed Java Programs",
    booktitle = "{SPIN}",
    pages = "224-244",
    year = "2000",
    url = "ftp://ftp.cs.indiana.edu/pub/techreports/TR536.ps" 
}

@misc{ JASPA-BENCHMARK,
  author ="JASPA Benchmark",
  title = "http://www.dl.ac.uk/TCSC/Staff/HuYF/SOFTWARE/JASPA/"
}

@misc{ MCCA,
  author ="Matrix MCCA from Matrix Market",
  title = "http://math.nist.gov/MatrixMarket/data/Harwell-Boeing/astroph/mcca.html"
}

@misc{ JGF,
  author ="Java Grande Forum Benchmark Suite",
  title = "http://www.epcc.ed.ac.uk/javagrande/threads/contents.html"
}

@misc{ NPTL,
  author ="Native posix thread library (NPTL)",
  title = "http://people.redhat.com/drepper/nptl-design.pdf"
}

@misc{ GNUCLASSPATH,
  author ="GNU Classpath",
  title = "http://www.gnu.org/software/classpath/classpath.html"
}

@misc{ IBM,
  author ="IBM",
  title = "http://www.ibm.com"
}

@misc{ SUN,
  author ="SUN",
  title = "http://www.sun.com"
}

@misc{ KAFFE,
  author ="KAFFE Java Virtual Machine",
  title = "http://www.kaffe.org"
}

@misc{ LATTE,
  author ="LaTTe Java Virtual Machine",
  title = "http://www.cs.rochester.edu/u/wei/runtime.html"
}

@misc{ KISSME,
  author ="kissme Java Virtual Machine",
  title = "http://kissme.sourceforge.net/"
}

@misc{ JAPHAR,
  author ="Japhar Java Virtual Machine",
  title = "http://www.japhar.org"
}

@misc{ CACAO,
  author ="CACAO Java Virtual Machine",
  title = "http://www.complang.tuwien.ac.at/java/cacao/"
}

@misc{ SABLEVM,
  author ="The Sable Java Virtual Machine",
  title = "http://www.sablevm.com"
}

@inproceedings{ dwyer99slicing,
    author = "Matthew B. Dwyer and John Hatcliff",
    title = "Slicing Software for Model Construction",
    booktitle = "Partial Evaluation and Semantic-Based Program Manipulation",
    pages = "105-118",
    year = "1999",
    url = "citeseer.nj.nec.com/dwyer99slicing.html" }



